Highlights:
   - **Android**
      - Add initial support of Android in GGUI (#3845) (by **Gabriel H**)
      - Add initial support of the platform (#3755) (by **Gabriel H**)
   - **Bug fixes**
      - Ban redefinition of template and matrix arguments in Taichi kernel (#4080) (by **Lin Jiang**)
      - Query device attribute when using cuda 11 and above (#3930) (by **Bo Qiao**)
      - Fix copying a Matrix/Struct in Taichi scope (#3838) (by **Yi Xu**)
      - Modify the implementation of norm_sqr() (#3803) (by **Yi Xu**)
   - **Documentation**
      - Tweak API docstrings (#3820) (by **Ye Kuang**)
      - Refactored contribution guidelines (#3789) (by **Vissidarte-Herman**)
      - Fix a misspelling (#3773) (by **张皓**)
   - **Error messages**
      - Add error message when non-0d numpy ndarray is given to initialize expression (#4030) (by **Lin Jiang**)
      - Produce a warning when users call external functions (#4007) (by **Lin Jiang**)
      - Shorten the length of traceback of TaichiCompilationError (#3965) (by **Lin Jiang**)
      - Add TaichiTypeError (#3964) (by **Lin Jiang**)
      - Raise exception when encountering undefined name (#3951) (by **Lin Jiang**)
      - Do not show body in exceptions in nodes with body (#3940) (by **Lin Jiang**)
      - Shorten the length of traceback of exceptions thrown by ASTTransformer (#3873) (by **lin-hitonami**)
   - **Examples**
      - Fix constraint correction (#3740) (by **Peng Yu**)
   - **GUI**
      - Fix gui.text crash bug (#3770) (by **Peng Yu**)
   - **Language and syntax**
      - Stop misusing non-template argument types to determine template reinstantiation (#4049) (by **Xiangyun Yang**)
      - Provide sparse matrix shape (#3959) (by **Peng Yu**)
      - Initial matrix argument support for ti.kernel (#3905) (by **Xiangyun Yang**)
      - Enable dynamic indexing of matrix field elements when possible (#3865) (by **Yi Xu**)
      - Use ndarray own memory allocator by default (#3843) (by **Bo Qiao**)
      - User-friendly exception when copying between ti.field (#3442) (by **J. Li**)
      - Enforce single deterministic return in taichi kernels and functions (#3795) (by **lin-hitonami**)
      - Add "In" support in static scope (#3792) (by **lin-hitonami**)
      - Support sparse solver datatype configuration (#3733) (by **Peng Yu**)
      - Fix pylint rule C0321 (multiple-statements) and C0325 (superfluous-parens). (#3762) (by **kxxt**)
      - Enforce members of a matrix field to have same shape (#3761) (by **Yi Xu**)
      - Fix pylint rule W1309 (f-string-without-interpolation) (#3757) (by **kxxt**)
   - **LLVM backend (CPU and CUDA)**
      - Remove the dependency of llvm-as (#3562) (by **Tianshu Xu**)
   - **Metal backend**
      - Pass random seed to metal backend (#3724) (by **Jian Zeng**)
   - **Miscellaneous**
      - Support logging on Android platforms (#3849) (by **Gabriel H**)
   - **Performance improvements**
      - Unnecessary assignment as it is redefined (#3753) (by **skywf**)
   - **Refactor**
      - Remove all occurrences of print_preprocessed and print_ast (#3911) (by **Xiangyun Yang**)
      - Deprecate excepthook and completely remove _taichi_skip_traceback (#3902) (by **Haidong Lan**)
   - **Tests**
      - Add initial AOT CPP test (#3850) (#3899) (by **Gabriel H**)
      - Add initial AOT CPP test (#3850) (by **Gabriel H**)
   - **Vulkan backend**
      - Update AOT Loader support to new API (#3766) (by **Gabriel H**)

Full changelog:
   - [opengl] Use element_size as alignment in root buffer. (#4095) (by **Ailing**)
   - [javascript] Add TI_EMSCRIPTENED to cmake options (JS 1/n) (#4093) (by **Dunfan Lu**)
   - [javascript] Add Javascript PR tag (JS 0/n) (#4094) (by **Dunfan Lu**)
   - [opt] Remove legacy vectorization pass (#4096) (#4099) (by **daylily**)
   - [refactor] [ir] Refactor ExternalFuncCallExpression into a frontend statement (#4098) (by **daylily**)
   - [spirv] Add names to buffer struct types and pointers (#4092) (by **Bob Cao**)
   - [test] Add a test for the minimization example (#4091) (by **Zydiii**)
   - [refactor] Remove dependency on get_current_program() in ui/backends/vulkan (#4076) (by **PGZXB**)
   - [refactor] [ir] Use InternalFuncCall for retrieving thread index (#4090) (by **daylily**)
   - Add images to GL device API (#4084) (by **Bob Cao**)
   - [dx11] Add underlying DX11 device, memory allocation, and some tests (#3971) (by **quadpixels**)
   - [Bug] [lang] Ban redefinition of template and matrix arguments in Taichi kernel (#4080) (by **Lin Jiang**)
   - [bug] Fix warnings on external functions on windows (#4079) (by **Lin Jiang**)
   - [aot] [vulkan] Provide range_hint for range_for offloaded tasks in vulkan backend. (by **Ailing Zhang**)
   - [refactor] Reuse SNode tree id (#4056) (by **Lin Jiang**)
   - [bug] Fix ndrange with star arguments (#4077) (by **Lin Jiang**)
   - [aot] [opengl] Provide range_hint for range_for offloaded tasks in (by **Ailing Zhang**)
   - [misc] Add a minimal example for micro-benchmarks (#4031) (by **rocket**)
   - [doc] Refactor type system doc: primitive types (#4055) (by **Yi Xu**)
   - [misc] Migrate benchmarks to a new version (#4059) (by **rocket**)
   - [refactor] Re-export some functions called directly by ASTTransfomer.* as member of ASTBuilder (#4034) (by **PGZXB**)
   - [autodiff] Fix the local allocas defining in inner loop raising runtime error (#4041) (by **Mingrui Zhang**)
   - [opengl] Make sure ndarray arg bind indices are sorted. (#4069) (by **Ailing**)
   - [doc] Improve operator page (#4067) (by **Bo Qiao**)
   - [ir] [refactor] Make ReturnStmt support a vector of stmts (#4028) (by **Xiangyun Yang**)
   - [Lang] [bug] Stop misusing non-template argument types to determine template reinstantiation (#4049) (by **Xiangyun Yang**)
   - [misc] Version bump: v0.8.10 -> v0.8.11 (#4053) (by **rocket**)
   - [test] [example] Add test and video generator for cornell box. (#4045) (by **Ailing**)
   - [bug] Fix bug that building with TI_WITH_LLVM=OFF will fail (#4043) (by **PGZXB**)
   - [doc] Improve type system documentation (#4002) (by **Bo Qiao**)
   - [Error] Add error message when non-0d numpy ndarray is given to initialize expression (#4030) (by **Lin Jiang**)
   - [Error] Produce a warning when users call external functions (#4007) (by **Lin Jiang**)
   - [aot] Use element_shape instead of row_num & column_num for CompiledFieldData. (by **Ailing Zhang**)
   - [vulkan] [aot] Switch vulkan aot to use taichi::aot::ModuleData. (by **Ailing Zhang**)
   - [vulkan] Fix gtmp type (#4042) (by **Bob Cao**)
   - [doc] Add an operation page (#4004) (by **Bo Qiao**)
   - [ir] [refactor] Split stmt typechecking to the frontend (#3875) (by **daylily**)
   - [build] Disable LTO for mac. (#4027) (by **Ailing**)
   - [autodiff] Restrict Independent Block scope for cases with atomic operations on global variables (#3897) (by **Mingrui Zhang**)
   - [gui] GGUI imwrite BGRA to RGBA conversion (#4018) (by **Bob Cao**)
   - [test] [example] Add a test and a video generator for mpm99 (#3995) (by **Yi Xu**)
   - [doc] [ci] Update Docs preview settings. (#4021) (by **Chengchen(Rex) Wang**)
   - [vulkan] [aot] Throw error for templated kernels in vulkan aot. (by **Ailing Zhang**)
   - [bug] [opt] Treat PtrOffsetStmt as random-initialized (#3998) (by **Yi Xu**)
   - [ci] Keep macOS actions run on macOS-10.15 (#4014) (by **rocket**)
   - [vulkan] [aot] Enable aot tests for vulkan backend. (#4000) (by **Ailing**)
   - [mesh] [opt] Experimental automatic mesh_local (#3989) (by **Chang Yu**)
   - [doc] Add doc for compile-time recursion (#3994) (by **Lin Jiang**)
   - [refactor] [opengl] Get rid of some no-ops in linear seek (by **Ailing Zhang**)
   - [opengl] Do not promote simple ExternalTensorShapeAlongAxisStmt into globals. (by **Ailing Zhang**)
   - [build] Upgrade SPIRV-Headers and SPIRV-Tools to their latest commits (#3967) (by **PGZXB**)
   - [opengl] [aot] Convert opengl aot to dump ModuleData. (#3991) (by **Ailing**)
   - [mesh] Support multiple major relations in one mesh-for loop (#3987) (by **Chang Yu**)
   - [refactor] Refactor func body to reduce python overhead and improve readability (#3984) (by **Haidong Lan**)
   - [opt] Add more strict alias analysis for ExternalPtrStmt (#3992) (by **Ailing**)
   - [opt] Accelerate whole_kernel_cse pass (#3957) (by **Xiangyun Yang**)
   - [mesh] [opt] Support nested mesh-for (#3990) (by **Chang Yu**)
   - [Lang] Provide sparse matrix shape (#3959) (by **Peng Yu**)
   - [refactor] Remove dependency on get_current_program() in backends/cpu and backends/cuda (#3956) (by **PGZXB**)
   - [mesh] Demote from-end element attribute atomic op (#3923) (by **Chang Yu**)
   - [ci] Support rebase and rerun command in comment for CI bot (#3952) (by **Frost Ming**)
   - [refactor] [ci] Enable identifier naming in clang-tidy (#3960) (by **Bo Qiao**)
   - [refactor] [ir] Use FrontendExprStmt in place of FrontendEvalStmt (#3978) (by **daylily**)
   - [example] [test] Fix misuse of logical operators in examples and tests (#3976) (by **Yi Xu**)
   - [Error] Shorten the length of traceback of TaichiCompilationError (#3965) (by **Lin Jiang**)
   - [aot] Add a generic set of AOT structs (#3973) (by **Ye Kuang**)
   - [Error] Add TaichiTypeError (#3964) (by **Lin Jiang**)
   - [aot] Add task_type for OpenGL (#3962) (by **Ye Kuang**)
   - [Error] Raise exception when encountering undefined name (#3951) (by **Lin Jiang**)
   - [misc] [cuda] Set the toolkit used by KernelProfiler at runtime (#3945) (by **rocket**)
   - [refactor] Get global vars by using __globals__ (#3949) (by **Lin Jiang**)
   - [refactor] Support static short circuit bool operations (#3958) (by **Lin Jiang**)
   - [perf] [refactor] Reduce kernel launch context construction overhead (#3947) (by **Haidong Lan**)
   - [refactor] Move python/taichi/lang/meta.py to python/taichi/_kernels.py (by **Ailing Zhang**)
   - [refactor] Remove import taichi in taichi/lang/impl.py (by **Ailing Zhang**)
   - [refactor] Remove ndarray_use_torch from pybind (#3946) (by **Bo Qiao**)
   - [ci] Test opengl backend on windows (#3924) (by **Frost Ming**)
   - [Error] Do not show body in exceptions in nodes with body (#3940) (by **Lin Jiang**)
   - [opt] Get store_to_load_forwarding work with local tensors across basic blocks (#3942) (by **Yi Xu**)
   - [refactor] [ir] Remove legacy stmts from CHI IR (#3943) (by **Yi Xu**)
   - [Error] Shorten the length of traceback of exceptions thrown by ASTTransformer (#3873) (by **lin-hitonami**)
   - [misc] Version bump: v0.8.9 -> v0.8.10 (#3935) (by **Bo Qiao**)
   - [ci] Install torch for windows release (#3932) (by **Bo Qiao**)
   - fix the ttf path (#3931) (by **Xiangyun Yang**)
   - [Bug] [cuda] Query device attribute when using cuda 11 and above (#3930) (by **Bo Qiao**)
   - [refactor] Optimize vector and matrix ndarray fill (#3921) (by **Bo Qiao**)
   - [opt] [ir] [refactor] Remove exceptions from offload pass (#3925) (by **Xiangyun Yang**)
   - [opt] [refactor] Remove the variable_optimization pass (#3927) (by **Mingkuan Xu**)
   - [doc] Add a tutorial: Run Ndarray Taichi program (#3908) (by **Vissidarte-Herman**)
   - [opt] [ir] [refactor] Remove exceptions from lower_ast pass (#3916) (by **Xiangyun Yang**)
   - [cuda] Use cuMemsetD32 to fill scalar ndarray (#3907) (by **Bo Qiao**)
   - [ci] Add self-hosted Windows buildbot for GPU testing (#3852) (by **Frost Ming**)
   - [Lang] Initial matrix argument support for ti.kernel (#3905) (by **Xiangyun Yang**)
   - [doc] Add example of color_edit_3 (#3919) (by **Vineyo**)
   - [perf] Clear global_vars/matrix_fields after materialize() (#3914) (by **Yi Xu**)
   - [gui] Update camera.py (#3898) (by **stamnug**)
   - [bug] Enable field-related checks in materialize() not only in first call (#3906) (by **Yi Xu**)
   - [Refactor] Remove all occurrences of print_preprocessed and print_ast (#3911) (by **Xiangyun Yang**)
   - [perf] Avoid using property for simple attributes to reduce python overhead. (by **Ailing Zhang**)
   - [opengl] Respect max_block_dim in ti.init (by **Ailing Zhang**)
   - [dx11] Add DX11 device interface definition (#3880) (by **quadpixels**)
   - [Refactor] Deprecate excepthook and completely remove _taichi_skip_traceback (#3902) (by **Haidong Lan**)
   - [opengl] Optimize range_for for ndarrays (by **Ailing Zhang**)
   - [Test] [aot] Add initial AOT CPP test (#3850) (#3899) (by **Gabriel H**)
   - [refactor] Merge taichi/lang/linalg_impl.py into _funcs.py (by **Ailing Zhang**)
   - [refactor] Remove import taichi in taichi/lang/quant_impl.py (by **Ailing Zhang**)
   - [refactor] Remove import taichi in taichi/lang/util.py (by **Ailing Zhang**)
   - [cuda] Increase saturating grid dim to reduce tail effect (#3855) (by **Bo Qiao**)
   - [opengl] Reduce repeated read to args buffer. (by **Ailing Zhang**)
   - [refactor] Remove import taichi from lang/__init__.py (#3889) (by **Yi Xu**)
   - Revert "[Test][aot] Add initial AOT CPP test (#3850)" (#3890) (by **Ye Kuang**)
   - [Android] [gui] Add initial support of Android in GGUI (#3845) (by **Gabriel H**)
   - [Test][aot] Add initial AOT CPP test (#3850) (by **Gabriel H**)
   - [Lang] Enable dynamic indexing of matrix field elements when possible (#3865) (by **Yi Xu**)
   - [cuda] Hide debug info (#3878) (by **Ye Kuang**)
   - [refactor] Remove legacy helper functions for testing (#3874) (by **Yi Xu**)
   - [refactor] Remove import taichi from expr.py (#3871) (by **Yi Xu**)
   - [refactor] Remove import taichi from field.py (#3870) (by **Yi Xu**)
   - [refactor] Remove import taichi from mesh.py (#3869) (by **Yi Xu**)
   - [refactor] Remove import taichi in ast_transformer (#3827) (by **lin-hitonami**)
   - [refactor] Remove import taichi from struct.py (#3866) (by **lin-hitonami**)
   - [autodiff] Provide stmt name for auto-diff related assert info (#3864) (by **Mingrui Zhang**)
   - [lang] Cleanup parallel sort utility (#3858) (by **Dunfan Lu**)
   - [refactor] Enforce destruction order of OpenGlRuntime. (#3861) (by **Ailing**)
   - [refactor] Add _MatrixFieldElement class (#3862) (by **Yi Xu**)
   - [opt] Add more accurate alias analysis for ExternalPtrStmt (#3859) (by **Yi Xu**)
   - [mesh] A small fix for mesh loop syntax in python frontend (#3836) (by **bx2k**)
   - [test] Add more complicated tests for building and destroying SNodeTrees (#3415) (by **ysh329**)
   - [lang] Calculate dynamic indexing strides of matrix field elements (#3854) (by **Yi Xu**)
   - [bug] Fix autodiff for ceil. (#3844) (by **Ailing**)
   - [refactor] Remove import taichi in matrix.py (#3842) (by **lin-hitonami**)
   - [Misc] [android] Support logging on Android platforms (#3849) (by **Gabriel H**)
   - [opengl] Allocate new arg bufs per kernel launch (#3848) (by **Ailing**)
   - [opengl] Only sync per ti.kernel when there's external array arg. (by **Ailing Zhang**)
   - [refactor] Rename is_external_array -> is_array and arr_bufs_ -> ext_arr_bufs_ (by **Ailing Zhang**)
   - [opengl] Only bind buffers per ti.kernel. (by **Ailing Zhang**)
   - [misc] Version bump: v0.8.8 -> v0.8.9 (#3846) (by **Yi Xu**)
   - [misc] Fix postsubmit status in README.md by replacing it with publishing checks (#3840) (by **Velaciela**)
   - [Lang] Use ndarray own memory allocator by default (#3843) (by **Bo Qiao**)
   - memset before reusing memory (#3841) (by **Bo Qiao**)
   - [refactor] Recover 'in' operator in vector_to_fast_image() (#3839) (by **Yi Xu**)
   - [Bug] [lang] Fix copying a Matrix/Struct in Taichi scope (#3838) (by **Yi Xu**)
   - [refactor] Remove import taichi in common_ops.py (#3824) (by **lin-hitonami**)
   - [vulkan] Fix command serial ordering & uses less queue submits (#3818) (by **Bob Cao**)
   - [ci] Enforce using ninja on Windows in both release and normal testing (#3837) (by **Yi Xu**)
   - [lang] Fix ndarray cuda dealloc when using preallocated memory (#3829) (by **Bo Qiao**)
   - [Lang] User-friendly exception when copying between ti.field (#3442) (by **J. Li**)
   - [refactor] Remove import taichi in kernel_impl.py (#3825) (by **lin-hitonami**)
   - Update TaichiCXXFlags.cmake (#3823) (by **Bob Cao**)
   - [bug] Fix static grouped for (#3822) (by **lin-hitonami**)
   - [misc] Slient & non-blocking version check (#3816) (by **Jiasheng Zhang**)
   - [doc] Editorial updates to contributor_guide.md (#3806) (by **Vissidarte-Herman**)
   - [Vulkan] Update AOT Loader support to new API (#3766) (by **Gabriel H**)
   - [Doc] Tweak API docstrings (#3820) (by **Ye Kuang**)
   - [ci] Use clang+Ninja to build Taichi on windows (#3735) (by **Bob Cao**)
   - [LLVM] Remove the dependency of llvm-as (#3562) (by **Tianshu Xu**)
   - [build] No need to build main executable (#3804) (by **Frost Ming**)
   - [lang] Add parallel sort utility (#3790) (by **Dunfan Lu**)
   - [misc] [bug] Fix legacy benchmarks/run.py (#3812) (by **rocket**)
   - [refactor] Move CompiledFieldData to aot namespace. (#3797) (by **Ailing**)
   - [docs] Update README.md to include command to install nightly. (#3809) (by **Ailing**)
   - [Lang] Enforce single deterministic return in taichi kernels and functions (#3795) (by **lin-hitonami**)
   - [bug] Fix typo in opengl codegen. (#3801) (by **Ailing**)
   - [bug] Use NdarrayRwKeys for ndarray host reader & writer caching. (#3805) (by **Ailing**)
   - [Bug] [opengl] Modify the implementation of norm_sqr() (#3803) (by **Yi Xu**)
   - [bug] Create core folder if it doesn't exist. (#3799) (by **Ailing**)
   - [doc] Update CONTRIBUTING.md to include contribution opportunities (#3794) (by **Ye Kuang**)
   - [Doc] Refactored contribution guidelines (#3789) (by **Vissidarte-Herman**)
   - [refactor] Move ti.lib to ti._lib and move ti.core to ti._lib.core (#3731) (by **lin-hitonami**)
   - [Lang] Add "In" support in static scope (#3792) (by **lin-hitonami**)
   - [ir] [llvm] Add offset_bytes_in_parent_cell to SNode (#3793) (by **Yi Xu**)
   - [bug] [opengl] Avoid using new as variable name in generated glsl. (#3786) (by **Ailing**)
   - [refactor] Move diagnose.py and cc_compose.py to tools/ (#3788) (by **lin-hitonami**)
   - [misc] Increase the kernel number recorded by CUPTI (#3780) (by **rocket**)
   - [vulkan] Try to enable Vulkan test in macOS presubmit (#3456) (by **Bob Cao**)
   - [llvm] [bug] Support atomic min/max for unsigned int type (#3779) (by **Chang Yu**)
   - [Lang] Support sparse solver datatype configuration (#3733) (by **Peng Yu**)
   - [gui] Fix vector to fast image (#3778) (by **Bob Cao**)
   - [Example] [bug] Fix constraint correction (#3740) (by **Peng Yu**)
   - [refactor] Remove get_type_size() from JITSession (#3777) (by **Yi Xu**)
   - [Lang] Fix pylint rule C0321 (multiple-statements) and C0325 (superfluous-parens). (#3762) (by **kxxt**)
   - [misc] Remove more deprecated APIs (#3774) (by **Zack Wu**)
   - [GUI] Fix gui.text crash bug (#3770) (by **Peng Yu**)
   - Fix spirv types (#3772) (by **Dunfan Lu**)
   - [Doc] Fix a misspelling (#3773) (by **张皓**)
   - [Lang] Enforce members of a matrix field to have same shape (#3761) (by **Yi Xu**)
   - [bug] Enable int32 atomic ops for opengl backend. (#3760) (by **Ailing**)
   - [gui] Fix ggui canvas.set_image (#3767) (by **Dunfan Lu**)
   - [test] Enable ndarray tests (#3759) (by **Bo Qiao**)
   - [Lang] Fix pylint rule W1309 (f-string-without-interpolation) (#3757) (by **kxxt**)
   - [Android] Add initial support of the platform (#3755) (by **Gabriel H**)
   - Update dev_install.md (#3758) (by **Vissidarte-Herman**)
   - [misc] Speed-up builds by removing LLVM includes from llvm_program.h (#3756) (by **Bob Cao**)
   - [Perf] Unnecessary assignment as it is redefined (#3753) (by **skywf**)
   - [ci] Update performance monitoring (#3741) (by **rocket**)
   - [opengl] Don't serialize ext_arr_access in aot. (#3749) (by **Ailing**)
   - [refactor] Move ti.randn out of taichi.lang. (#3742) (by **Ailing**)
   - [bug] Temporarily remove runtime_ usage in aot_module_builder. (#3746) (by **Ailing**)
   - [misc] Update title check to be more robust. (#3747) (by **Ailing**)
   - [Metal] Pass random seed to metal backend (#3724) (by **Jian Zeng**)
